/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "keplerBubble.h"

 KeplerBubble::KeplerBubble() : Game("Kepler-Bubble", "Kepler-Bubble"), nbPlayers(1){
	for(int i=1;i<8;i++) {
		colors.push_back(i);
	}
	//initFog (GL_LINEAR, 1., 0., 180., 14);	 
	//initCamera(DIST_INIT_KB, 60., 5., 160.,(SCREEN_WIDTH-SCREEN_HEIGHT)/2,0,SCREEN_HEIGHT, SCREEN_HEIGHT);
	//initLights ();	 
	//prism = new KeplerPrism();
 }
 
 /*KeplerBubble::KeplerBubble(std::vector<int> _colors, int _nbPlayers):
	Game(), colors(_colors), nbPlayers(_nbPlayers) {
	initFog (GL_LINEAR, 1., 0., 180., 14);	 
	//initCamera(DIST_INIT_KB, 60., 5., 150.,(SCREEN_WIDTH-SCREEN_HEIGHT)/2,0,SCREEN_HEIGHT, SCREEN_HEIGHT);
	initLights ();		
	//prism = new KeplerPrism();

}*/

KeplerBubble::~KeplerBubble() {
	//delete prism;
}

void KeplerBubble::initGame() {
	//reinitPosCamera();
	currentColor = nextColor();	
}

void KeplerBubble::reinitPosCamera() {
	Vector3 pos = Vector3(0.,0.,DIST_INIT_KB);
	//camera->setPositionLookingAtO(pos);
}

void KeplerBubble::initDisplayEnvironments() {
	
}

void KeplerBubble::createObjects () {
	
}

void KeplerBubble::createLights () {
	/*Vector3 position0 = Vector3(-(Y_PRISM-2.) /sqrt(3.), Y_PRISM-2. ,Z_MAX+10.);
	Vector3 position1 = Vector3(-Y_PRISM * 2./sqrt(3.) ,0. , Z_MAX+10.);
	Vector3 position2 = Vector3(-Y_PRISM /sqrt(3.), -Y_PRISM, Z_MAX+10.);
	Vector3 position3 = Vector3(Y_PRISM /sqrt(3.), -Y_PRISM , Z_MAX+10.);
	Vector3 position4 = Vector3(Y_PRISM * 2./sqrt(3.) ,0. , Z_MAX+10.);
	Vector3 position5 = Vector3(Y_PRISM /sqrt(3.), Y_PRISM, Z_MAX+10.); */

	//provisoire
	Vector3 position0 = Vector3(-(Y_PRISM-20.) /sqrt(3.), Y_PRISM-20. ,Z_MAX);
	//lights.push_back(new LightPoint(0, position0,2.));
	
	/*lights.push_back(new LightPoint(1, position0,3.));
	lights.push_back(new LightPoint(2, position1,1.));
	lights.push_back(new LightPoint(3, position2,3.));
	lights.push_back(new LightPoint(4, position3,1.));
	lights.push_back(new LightPoint(5, position4,3.));
	lights.push_back(new LightPoint(6, position5,1.));*/

	
	for(int i=0;i<lights.size();i++) {
			//lights[i]->setLinearAttenuation (0.005);
	}	
}

void KeplerBubble::quit() {
	
}

void KeplerBubble::updateAnimations(double currentTime, double intervalTime) {
	
}



int KeplerBubble::nextColor() {
	return (int) (1 + ((float) rand() / RAND_MAX * colors.size()));
}


bool KeplerBubble::keyboardEvent(SDLKey key, double timeInterval) {
	
}


void KeplerBubble::mouseMotion(int xOld, int yOld, int xNew, int yNew, bool left, bool middle, bool right) {

}

void KeplerBubble::leftClick(int x, int y) {

}
	
void KeplerBubble::rightClick(int x, int y) {

}

void KeplerBubble::middleClick(int x, int y) {

}

void KeplerBubble::mouseWheel(int w) {
		
}
